
#include <project.h>

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NO_OF_SAMPLES 1000
#define mod(m,r) ( ((m) % (r)) + ( (m)<0 ? (r):0 ))

uint8 currentTD,state,nextTD,ADC_SampleNo=0;
uint16 sourceAdress,destinationAdress,transferCount;
uint16 i,output,output_sar,DMA_Count_Temp0,DMA_Count_Temp1,DMA_Count_Temp2,DMA_Count_Temp3;

double temp_multiply=0,RMS[10]={0,0,0,0,0,0,0,0,0,0};
double temp_rms=0;

uint16 
ADC_Sample0[NO_OF_SAMPLES],
ADC_Sample1[NO_OF_SAMPLES],
ADC_Sample2[NO_OF_SAMPLES],
ADC_Sample3[NO_OF_SAMPLES];

float output_f[3];	
volatile uint8 DMADone_flag;

/* Defines for DMA_adc */
uint8 DMA_adc_Chan;
uint8 DMA_adc_TD[1];
#define DMA_adc_BYTES_PER_BURST (2u)
#define DMA_adc_REQUEST_PER_BURST (1u)
#define DMA_adc_SRC_BASE (CYDEV_PERIPH_BASE)
#define DMA_adc_DST_BASE (CYDEV_SRAM_BASE)
/* Defines for DMA_adc */

/* Defines for DMA_Uart */
uint8 DMA_Uart_Chan;
uint8 DMA_Uart_TD[2];
#define DMA_Uart_BYTES_PER_BURST (2u)
#define DMA_Uart_REQUEST_PER_BURST (1u)
#define DMA_Uart_SRC_BASE (CYDEV_SRAM_BASE)
#define DMA_Uart_DST_BASE (CYDEV_PERIPH_BASE)
/* Defines for DMA_Uart */

CY_ISR(Change)	
{
if(ADC_SampleNo==0)
    {
        ADC_DelSig_StopConvert();
        //PGA_Stop();
        Pin3_7_Write(1);
        CyDmaTdGetConfiguration(DMA_adc_Chan, &transferCount, 0, 0);

        DMA_Count_Temp0 = ((2*NO_OF_SAMPLES) - (transferCount))/2;
        CyDmaChSetRequest(DMA_adc_Chan, CPU_TERM_CHAIN);
        CyDmaTdFree(DMA_adc_TD[0]);
        DMA_adc_TD[0] = CyDmaTdAllocate();

        CyDmaTdSetConfiguration(DMA_adc_TD[0], (2*NO_OF_SAMPLES), DMA_adc_TD[0],
        DMA_adc__TD_TERMOUT_EN | TD_INC_DST_ADR);

        CyDmaTdSetAddress(DMA_adc_TD[0], LO16((uint32)ADC_DelSig_DEC_SAMP_PTR), LO16((uint32)ADC_Sample1));
        ADC_SampleNo=1;
        
        CyDmaChSetInitialTd(DMA_adc_Chan, DMA_adc_TD[0]);
        CyDmaChEnable(DMA_adc_Chan, 1);
    
        ADC_DelSig_StartConvert();
        DMADone_flag = 1;
        Pin3_7_Write(0);        

    }
else if(ADC_SampleNo==1)
    {
        ADC_DelSig_StopConvert();
        //PGA_Stop();
        Pin3_7_Write(1);
        CyDmaTdGetConfiguration(DMA_adc_Chan, &transferCount, 0, 0);

        DMA_Count_Temp1 = ((2*NO_OF_SAMPLES) - (transferCount))/2;
        CyDmaChSetRequest(DMA_adc_Chan, CPU_TERM_CHAIN);
        CyDmaTdFree(DMA_adc_TD[0]);
        DMA_adc_TD[0] = CyDmaTdAllocate();

        CyDmaTdSetConfiguration(DMA_adc_TD[0], (2*NO_OF_SAMPLES), DMA_adc_TD[0],
        DMA_adc__TD_TERMOUT_EN | TD_INC_DST_ADR);

        CyDmaTdSetAddress(DMA_adc_TD[0], LO16((uint32)ADC_DelSig_DEC_SAMP_PTR), LO16((uint32)ADC_Sample2));
        ADC_SampleNo=2;
        
        CyDmaChSetInitialTd(DMA_adc_Chan, DMA_adc_TD[0]);
        CyDmaChEnable(DMA_adc_Chan, 1);
    
        ADC_DelSig_StartConvert();
        DMADone_flag = 1;
        Pin3_7_Write(0);        

    }
else if(ADC_SampleNo==2)
    {
        ADC_DelSig_StopConvert();
        //PGA_Stop();
        Pin3_7_Write(1);
        CyDmaTdGetConfiguration(DMA_adc_Chan, &transferCount, 0, 0);

        DMA_Count_Temp2 = ((2*NO_OF_SAMPLES) - (transferCount))/2;
        CyDmaChSetRequest(DMA_adc_Chan, CPU_TERM_CHAIN);
        CyDmaTdFree(DMA_adc_TD[0]);
        DMA_adc_TD[0] = CyDmaTdAllocate();

        CyDmaTdSetConfiguration(DMA_adc_TD[0], (2*NO_OF_SAMPLES), DMA_adc_TD[0],
        DMA_adc__TD_TERMOUT_EN | TD_INC_DST_ADR);

        CyDmaTdSetAddress(DMA_adc_TD[0], LO16((uint32)ADC_DelSig_DEC_SAMP_PTR), LO16((uint32)ADC_Sample3));
        ADC_SampleNo=3;
        
        CyDmaChSetInitialTd(DMA_adc_Chan, DMA_adc_TD[0]);
        CyDmaChEnable(DMA_adc_Chan, 1);
    
        ADC_DelSig_StartConvert();
        DMADone_flag = 1;
        Pin3_7_Write(0);        

    }
else if(ADC_SampleNo==3)
    {
        ADC_DelSig_StopConvert();
        //PGA_Stop();
        Pin3_0_Write(1);
        CyDmaTdGetConfiguration(DMA_adc_Chan, &transferCount, 0, 0);

        DMA_Count_Temp3 = ((2*NO_OF_SAMPLES) - (transferCount))/2;
        CyDmaChSetRequest(DMA_adc_Chan, CPU_TERM_CHAIN);
        CyDmaTdFree(DMA_adc_TD[0]);
        DMA_adc_TD[0] = CyDmaTdAllocate();

        CyDmaTdSetConfiguration(DMA_adc_TD[0], (2*NO_OF_SAMPLES), DMA_adc_TD[0],
        DMA_adc__TD_TERMOUT_EN | TD_INC_DST_ADR);

        CyDmaTdSetAddress(DMA_adc_TD[0], LO16((uint32)ADC_DelSig_DEC_SAMP_PTR), LO16((uint32)ADC_Sample0));
        ADC_SampleNo=0;
        
        CyDmaChSetInitialTd(DMA_adc_Chan, DMA_adc_TD[0]);
        CyDmaChEnable(DMA_adc_Chan, 1);
    
        ADC_DelSig_StartConvert();
        DMADone_flag = 1;
        Pin3_0_Write(0);        

    }
    
    ISR_DMA_Change_ClearPending();    
    
}
void DMA_ADC_config (void)
{
    /* DMA Configuration for DMA_adc */
    DMA_adc_Chan = DMA_adc_DmaInitialize(DMA_adc_BYTES_PER_BURST, DMA_adc_REQUEST_PER_BURST, 
        HI16(DMA_adc_SRC_BASE), HI16(DMA_adc_DST_BASE));

    DMA_adc_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_adc_TD[0], (2*NO_OF_SAMPLES), DMA_adc_TD[0],
        DMA_adc__TD_TERMOUT_EN | TD_INC_DST_ADR);

    CyDmaTdSetAddress(DMA_adc_TD[0], LO16((uint32)ADC_DelSig_DEC_SAMP_PTR), LO16((uint32)ADC_Sample0));
    CyDmaChSetInitialTd(DMA_adc_Chan, DMA_adc_TD[0]);
    CyDmaChEnable(DMA_adc_Chan, 1);

    CyDmaTdGetConfiguration(DMA_adc_TD[0], &transferCount, 0, 0); 
    CyDmaTdGetAddress(DMA_adc_TD[0], &sourceAdress, &destinationAdress);    
}
int main(void)
{    
    UART_Start();
ISR_DMA_Change_StartEx(&Change);
DMA_ADC_config();
//DMA_Uart_Config();
CyGlobalIntEnable;
DVDAC_SetValue(0x170);
DVDAC_Start();

Comp_Start();

ADC_DelSig_Start();
ADC_DelSig_IRQ_Stop();
LPF_Start();
PGA_Start();

DMA_Count_Temp0 = DMA_Count_Temp1 = DMA_Count_Temp2 = DMA_Count_Temp3 = 0;
CyDelay(1);
DMADone_flag = 1;
    for(;;)
    {

        if(DMADone_flag)
        {
            Pin6_3_Write(1);
            temp_multiply = 0;
            if(ADC_SampleNo == 0)
            {
                //DFB                
                for(i=0;i<DMA_Count_Temp3;i++)
                {
                    temp_multiply += ((double)ADC_Sample3[i]*(double)ADC_Sample3[i]);
                }
            }
            else if(ADC_SampleNo == 1)
            {
                //DFB
                for(i=0;i<DMA_Count_Temp0;i++)
                {
                    temp_multiply += ((double)ADC_Sample0[i]*(double)ADC_Sample0[i]);
                }                
            }
            else if(ADC_SampleNo == 2)
            {
                //DFB
                for(i=0;i<DMA_Count_Temp1;i++)
                {
                    temp_multiply += ((double)ADC_Sample1[i]*(double)ADC_Sample1[i]);
                }
            }
            else if(ADC_SampleNo == 3)
            {
                //DFB
                for(i=0;i<DMA_Count_Temp2;i++)
                {
                    temp_multiply += ((double)ADC_Sample2[i]*(double)ADC_Sample2[i]);
                }
            }
            temp_rms = temp_multiply/(double)i;
            
            RMS[0] = sqrt(temp_rms);
            output_f[1] = (float)RMS[0];
            
            RMS[0] = RMS[0] +RMS[1] +RMS[2] +RMS[3] +RMS[4]
                      + RMS[5] +RMS[6] +RMS[7] +RMS[8] +RMS[9];

            RMS[0] = (RMS[0]/10.0);                
            output_f[0] = (float)RMS[0];                
            
            RMS[9] = RMS[8];
            RMS[8] = RMS[7];
            RMS[7] = RMS[6];
            RMS[6] = RMS[5];                
            RMS[5] = RMS[4];                
            RMS[4] = RMS[3];
            RMS[3] = RMS[2];
            RMS[2] = RMS[1];
            RMS[1] = RMS[0];
            
            UART_PutChar(0x11);
            UART_PutArray((uint8*)&output_f[0],4);
            UART_PutArray((uint8*)&output_f[1],4);
            //UART_PutChar(3);
            //UART_PutChar(0xee);
            Pin6_3_Write(0); 
            
            DMADone_flag = 0; 
         
        }
    }
}
